/*
 * Copyright Ian Burnett 2005, 2006.
 *
 * This file is part of Ian's Interactive LCD controller (IILC).
 * 
 * IILC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * IILC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with IILC; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA.
 */

#if !defined(__CONFIG_H__)
#define __CONFIG_H__

#include "lcd.h"

enum displayObjectType
{
    OBJECT_TYPE_FAN,
    OBJECT_TYPE_LED,
    OBJECT_TYPE_TEMP
};


void startParse(void);

void parserSetDisplayDevice(char * pszDevice);

void parserSetDeviceClass(char * pszClass);

void parserSetDevicePort(char * pszPort);

void parserBeginDisplay(char * pszDisplay);

void parserEndDisplay(void);

void parserBeginModule(char * pszModule);

void parserSetModuleLibrary(char * pszLibrary);

void parserEndModule(void);

void parserBeginScreen(char * pszScreen);

void parserEndScreen(void);

void parserModuleControlObject(char * pszObject, 
                               int control_as_id);

void parserModuleReportObject(char * pszObject,
                              int report_as_id);

void parserModuleVirtualObject(int physical_id,
                               char * pszObject);

void parserDeviceBegin(char * pszDevice);

void parserDeviceUseFan(int id, 
                        char * pszName);

void parserDeviceUseLED(int id, 
                        char * pszName);

void parserDeviceUseTemp(int id, 
                         char * pszName);

void parserDeviceEnd(void);

int  parserDeviceCreateObject(int physical_id, 
                              char * pszName, 
                              enum displayObjectType type, 
                              LPCONFIG_OBJECT * ppObject);

int parserDeviceFindObject(LPCONFIG_DEVICE pDevice, 
                           char * pszObject, 
                           LPCONFIG_OBJECT * ppObject);

#endif
