/*
 * Copyright Ian Burnett 2005, 2006.
 *
 * This file is part of Ian's Interactive LCD controller (IILC).
 * 
 * IILC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * IILC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with IILC; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA.
 */

#if !(defined __DISPLAY_H__)
#define __DISPLAY_H__

#include "lcd.h"
#include "device.h"

typedef struct _tag_display * LPDISPLAY;



LCD_API int displayCreate(LPDEVICE pDevice,
                          LPDISPLAY * ppDisplay);

LCD_API int displayOpen(LPDISPLAY pDisplay);

LCD_API int displayClose(LPDISPLAY pDisplay);

LCD_API int displayDestroy(LPDISPLAY * ppDisplay);

LCD_API int displayGetSize(LPDISPLAY pDisplay,
                           int * width,
                           int * height);

LCD_API int displayAddFanReportListener(LPDISPLAY pDisplay, 
                                        unsigned int fan_id,
                                        pfnFanReportListener pfnListener,
                                        void * context,
                                        unsigned int report_as_id);

LCD_API int displaySetTempReportListener(LPDISPLAY pDisplay, 
                                         pfnTempReportListener pfnListener,
                                         void * context);

LCD_API int displaySetKeyEventListener(LPDISPLAY pDisplay, 
                                       pfnKeyEventListener pfnListener,
                                       void * context);

int displayStart(LPDISPLAY pDisplay);

int displayStop(LPDISPLAY pDisplay);



#endif /* __DISPLAY_H__ */

