/*
 * Copyright Ian Burnett 2005, 2006.
 *
 * This file is part of Ian's Interactive LCD controller (IILC).
 * 
 * IILC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * IILC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with IILC; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA.
 */

#if !defined(__PROTOS_H__)
#define __PROTOS_H__


LPCONFIG_APP parserGetCurrentConfig();

LPCONFIG_DISPLAY parserGetCurrentDisplay();

LPCONFIG_MODULE parserGetCurrentModule();

LPCONFIG_DEVICE parserGetCurrentDevice();


int parserParse(const char * pszConfigFile,
                LPCONFIG_APP * ppAppConfig);


int configGetDeviceName(LPCONFIG_DEVICE pDevice, 
                        const char ** ppszName);

int configGetDisplayDeviceIndex(LPCONFIG_APP pConfig,
                                int nDisplayIndex, 
                                int * nDeviceIndex);

int configGetDeviceClass(LPCONFIG_DEVICE pDevice, 
                         const char ** ppszClass);

int configGetDevicePort(LPCONFIG_DEVICE pDevice, 
                        const char ** ppszPort);

int configGetDisplayDescr(LPCONFIG_DISPLAY pDisplay, 
                          const char ** ppszDescr);

int configGetModuleName(LPCONFIG_DISPLAY pDisplay, 
                        int nModuleIndex, 
                        char ** ppszName);

int configGetModuleCount(LPCONFIG_APP pConfig, 
                         int nDisplayIndex, 
                         int * pnCount);

int configGetDisplayCount(LPCONFIG_APP pConfig, 
                          int * pnCount);

int configInstanceDestroy(LPCONFIG_APP * ppInst);


void parserBeginDevice(char * pszDevice);

void parserEndDevice();

void parserSetDisplayDevice(char * pszDevice);

void parserSetDeviceClass(char * pszClass);

void parserSetDevicePort(char * pszPort);

void parserBeginDisplay(char * pszDisplay);

void parserEndDisplay();

void parserBeginModule(char * pszModule);

void parserSetModuleLibrary(char * pszLibrary);

void parserEndModule();

void parserBeginScreen(char * pszScreen);

void parserEndScreen();

int parserParse(const char * pszConfigFile,
                LPCONFIG_APP * ppAppConfig);


int processConfigModule(LPCONFIG_MODULE pModule);


int keypressCallback(void * context,
                     PACKET_KEY_EVENT key_event);



#endif /* __PROTOS_H__ */

